Name:    gofer
Version: 0.74
Release: 2
Summary: A lightweight, extensible python agent
Group:   Development/Other
License: LGPLv2
URL:     https://fedorahosted.org/gofer/
Source0: https://fedorahosted.org/releases/g/o/gofer/%{name}-%{version}.tar.gz
BuildArch: noarch
BuildRequires: gzip
BuildRequires: python-devel
BuildRequires: python-setuptools
BuildRequires: python-rpm
Requires: python-%{name} = %{version}
Requires: python-iniparse

%description
Gofer provides an extensible, light weight, universal python agent.
The gofer core agent is a python daemon (service) that provides
infrastructure for exposing a remote API and for running Recurring
Actions. The APIs contributed by plug-ins are accessible by Remote
Method Invocation (RMI). The transport for RMI is AMQP using the
QPID message broker. Actions are also provided by plug-ins and are
executed at the specified interval.

%prep
%setup -q

%build
pushd src
python setup.py build
popd
pushd docs/man/man1
gzip *
popd

%install
pushd src
python setup.py install -O1 --skip-build --root %{buildroot}
#pushd ruby
#mkdir -p %{buildroot}/%{ruby_sitelibdir}/%{name}/rmi
#mkdir -p %{buildroot}/%{ruby_sitelibdir}/%{name}/messaging
#cp %{name}.rb %{buildroot}/%{ruby_sitelibdir}
#pushd %{name}
#cp *.rb %{buildroot}/%{ruby_sitelibdir}/%{name}
#pushd rmi
#cp *.rb %{buildroot}/%{ruby_sitelibdir}/%{name}/rmi
#popd
#pushd messaging
#cp *.rb %{buildroot}/%{ruby_sitelibdir}/%{name}/messaging
#popd
#popd
#popd
popd

mkdir -p %{buildroot}/usr/bin
mkdir -p %{buildroot}/%{_sysconfdir}/%{name}
mkdir -p %{buildroot}/%{_sysconfdir}/%{name}/plugins
mkdir -p %{buildroot}/%{_sysconfdir}/%{name}/conf.d
mkdir -p %{buildroot}/%{_sysconfdir}/init.d
mkdir -p %{buildroot}/%{_var}/log/%{name}
mkdir -p %{buildroot}/%{_var}/lib/%{name}/journal/watchdog
mkdir -p %{buildroot}/%{_usr}/lib/%{name}/plugins
mkdir -p %{buildroot}/%{_usr}/share/%{name}/plugins
mkdir -p %{buildroot}/%{_mandir}/man1

cp bin/%{name}d %{buildroot}/usr/bin
cp etc/init.d/%{name}d %{buildroot}/%{_sysconfdir}/init.d
cp etc/%{name}/*.conf %{buildroot}/%{_sysconfdir}/%{name}
cp etc/%{name}/plugins/*.conf %{buildroot}/%{_sysconfdir}/%{name}/plugins
cp src/plugins/*.py %{buildroot}/%{_usr}/share/%{name}/plugins
cp docs/man/man1/* %{buildroot}/%{_mandir}/man1

rm -rf %{buildroot}/%{python_sitelib}/%{name}*.egg-info

# Disable virt plugin for now
rm -f %{buildroot}%{_sysconfdir}/%{name}/plugins/virt.conf
rm -f %{buildroot}%{_usr}/share/%{name}/plugins/virt.*

%files
%dir %{_sysconfdir}/%{name}/
%dir %{_sysconfdir}/%{name}/plugins
%dir %{_usr}/lib/%{name}/plugins/
%dir %{_usr}/share/%{name}/plugins/
%dir %{_sysconfdir}/%{name}/conf.d/
%dir %{_var}/log/%{name}/
%{python_sitelib}/%{name}/agent/
%{_bindir}/%{name}d
%attr(755,root,root) %{_sysconfdir}/init.d/%{name}d
%config(noreplace) %{_sysconfdir}/%{name}/agent.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/builtin.conf
%{_usr}/share/%{name}/plugins/builtin.*
%doc LICENSE
%doc %{_mandir}/man1/gofer*

%post
chkconfig --add %{name}d

%preun
if [ $1 = 0 ] ; then
   /sbin/service %{name}d stop >/dev/null 2>&1
   /sbin/chkconfig --del %{name}d
fi


###############################################################################
# python lib
###############################################################################

%package -n python-%{name}
Summary: Gofer python lib modules
Group: Development/Python
Obsoletes: %{name}-lib
BuildRequires: python
Requires: python-simplejson
Requires: python-qpid >= 0.7
Requires: pythonegg(pypam)
%if 0%{?rhel} && 0%{?rhel} < 6
Requires: python-hashlib
Requires: python-uuid
Requires: python-ssl
%endif

%description -n python-%{name}
Contains gofer python lib modules.

%files -n python-%{name}
%{python_sitelib}/%{name}/*.py*
%{python_sitelib}/%{name}/rmi/
%{python_sitelib}/%{name}/messaging/
%doc LICENSE

###############################################################################
# ruby lib
###############################################################################

#%package -n ruby-%{name}
#Summary: Gofer ruby lib modules
#Group: Development/Ruby
#BuildRequires: ruby
#Requires: rubygems
#Requires: rubygem(json)
#Requires: rubygem(qpid) >= 0.16.0
#
#%description -n ruby-%{name}
#Contains gofer ruby lib modules.
#
#%files -n ruby-%{name}
#%{ruby_sitelibdir}/%{name}.rb
#%{ruby_sitelibdir}/%{name}/*.rb
#%{ruby_sitelibdir}/%{name}/rmi/
#%{ruby_sitelibdir}/%{name}/messaging/
#%doc LICENSE
#

###############################################################################
# plugin: system
###############################################################################

%package -n gofer-system
Summary: The system plug-in
Group: Development/Other
BuildRequires: python
Requires: %{name} >= %{version}

%description -n gofer-system
Contains the system plug-in.
The system plug-in provides system functionality.

%files -n gofer-system
%config(noreplace) %{_sysconfdir}/%{name}/plugins/system.conf
%{_usr}/share/%{name}/plugins/system.*
%doc LICENSE


###############################################################################
# plugin: watchdog
###############################################################################

%package -n gofer-watchdog
Summary: The watchdog plug-in
Group: Development/Other
BuildRequires: python
Requires: %{name} >= %{version}

%description -n gofer-watchdog
Contains the watchdog plug-in.
This plug-in is used to support time out
for asynchronous RMI calls.

%files -n gofer-watchdog
%config(noreplace) %{_sysconfdir}/%{name}/plugins/watchdog.conf
%{_usr}/share/%{name}/plugins/watchdog.*
%{_var}/lib/%{name}/journal/watchdog
%doc LICENSE


###############################################################################
# plugin: virt
###############################################################################

#%package -n gofer-virt
#Summary: The virtualization plugin
#Group: Development/Other
#BuildRequires: python
#Requires: libvirt-python
#Requires: %{name} >= %{version}
#
#%description -n gofer-virt
#Contains the virtualization plugin.
#This plug-in provides RMI access to libvirt functionality.
#
#%files -n gofer-virt
#%config(noreplace) %{_sysconfdir}/%{name}/plugins/virt.conf
#%{_usr}/share/%{name}/plugins/virt.*
#%doc LICENSE
#

###############################################################################
# plugin: package
###############################################################################

%package -n gofer-package
Summary: The package (RPM) plugin
Group: Development/Other
BuildRequires: python
#Requires: yum
Requires: %{name} >= %{version}

%description -n gofer-package
Contains the package plugin.
This plug-in provides RMI access to package (RPM) management.

%files -n gofer-package
%config(noreplace) %{_sysconfdir}/%{name}/plugins/package.conf
%{_usr}/share/%{name}/plugins/package.*
%doc LICENSE

%changelog
* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 0.74-2
+ Revision: 79798fe
- MassBuild#440: Increase release tag


